#SerIO Python Example Interface
#E-Mail Checker
#Written by Ryan Owens
#SparkFun Electroncis
#
#Connects to an IMAP Mail Server. Turns on an LED if new mail is in the INBOX
#Circuit Description:
#LED plugeed into SerIO pin D2.

#Import IMAPLIB for interfacing with IMAP E-Mail Account
from imaplib import *

#Import Serial module to communicate with the SerIO platform (Serial Library can be downloaded fromn http://sourceforge.net/projects/pyserial/files/)
import serial
#Imprt Time module to use 'sleep' delays
import time

#Configure the IMAP settins
SERVER_NAME = "mail.server.com"
USER = "username"
PASSWORD = "password"

def main():
	#Connect to the mail server and select the inbox
	server = IMAP4(SERVER_NAME);
	server.login(USER, PASSWORD);
	server.list();
	box = server.select("Inbox");
	
	#initialize the serial port. The '8' parameter selects COM9.  Might be a good idea to scan for ports then chooses which COM port to open. Timeout is set to 5 seconds (way overkill).
	mySerial = serial.Serial(8, 57600, serial.EIGHTBITS, serial.PARITY_NONE, serial.STOPBITS_ONE, 5);
	
	#Wait for the 'Ready' response from the SerIO
	response = mySerial.readline();
	#print response;	#Uncomment this line to echo the ready response from the SerIO.
	
	#Send SerIO command to turn off the command echo
	size = mySerial.write("E,0\r");
	time.sleep(0.1);
	
	#Configure pin D2 as an output
	mySerial.write("C,2,1\r");
	response = mySerial.readline();
	#print response;		#Uncomment this command to echo the SerIO response to the configure pin command.
	
	#search the inbox for unseen e-mail.
	r, data = server.search(None, '(UNSEEN)');
	messages = data[0].split();
	#Find out how many unseen messages are in the Inbox
	new_messages = len(messages);
	
	#If there are unseen messages in the inbox, turn on the LED
	if new_messages > 0:
		#Send the command to turn on pin D2 on the SerIO.
		mySerial.write("W,2,1\r");
		#Wait for the response from the SerIO verifying the pin was turned on
		response = mySerial.readline();
		print response;
	else:
		#If no new messages are in the inbox, turn the LED off.
		mySerial.write("W,2,0\r");
		#Wait for the SerIO response verifying the LED was turned off.
		response = mySerial.readline();
		print response;			
	
	#Close the Serial Port
	mySerial.close();

if __name__ == "__main__":
    main();
	
